package org.mandarax.util.resultsetfilters.aggregationfunctions;

/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import org.mandarax.kernel.LogicFactory;
import org.mandarax.kernel.ResultSet;
import org.mandarax.kernel.VariableTerm;
import org.mandarax.util.resultsetfilters.AggregationException;
import org.mandarax.util.resultsetfilters.AggregationFunction;
 
/**
 * COUNT function. Counts records within a group.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 3.0
 */

public class COUNT implements AggregationFunction  {
	private static Class[] supportedTypes = {
		Object.class
	};
	private int counter = 0;
	/**
	 * Constructor.
	 * @param var the variable
	 */
	public COUNT() throws AggregationException  {
		super();
	}
	
	/**
	 * Copy this function (get a newly initialized instance of this class).
	 * @return a function
	 */
	public AggregationFunction copy() throws AggregationException  {
		return new COUNT();
	}
	
	/**
	 * Get the name of this function.
	 * @return a name
	 */
	public String getName() {
		return "COUNT";
	}
	/**
	 * Get an array of supported types.
	 * @return an array of types
	 */
	protected Class[] getSupportedTypes() {
		return supportedTypes;
	}
	/**
	 * Add a value. May throw an IllegalArgumentException
	 * indicating that this type of value cannot be aggregated.
	 * @param rs a result set
	 */
	public void add(ResultSet rs) throws AggregationException {
		counter++;
	}
	/**
	 * Get the aggregated value.
	 * @return a value
	 */
	public Object getAggregatedValue() throws AggregationException {
		return new Integer(counter);
	}
	/**
	 * Get the result type. This type might differ from the input type (e.g. when counting records).
	 * @return the result type
	 */
	public Class getResultType() {
		return Integer.class;
	}
	/**
	 * Set the type.
	 * @param clazz a type.
	 */
	public void setType(Class clazz) throws AggregationException {
	}
	/**
	 * Get the variable that can be used to retrieve the value from
	 * the filtered result set.
	 * @return a variable name
	 */
	public VariableTerm getVariableInResult() {
		return LogicFactory.getDefaultFactory().createVariableTerm("COUNT(*)",getResultType());		
	}
}
